package com.demo.util;


import com.demo.common.SpecialSecret;
import com.reyun.Algorithm;

import javax.crypto.Cipher;
import javax.crypto.CipherInputStream;
import javax.crypto.CipherOutputStream;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URLEncoder;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.charset.Charset;
import java.security.Key;
import java.util.Random;


/**
 *
 * 文件加密
 *
 */
public class FileEncryptor {


	private static final String ALGORITHM = "AES";
	private static final int CACHE_SIZE = 1024;

	/**
	 * <p>
	 * 文件加密
	 * </p>
	 *
	 * @param key
	 * @param sourceFilePath
	 * @param destFilePath
	 * @throws Exception
	 */
	public static void encryptFile(String key, String sourceFilePath, String destFilePath) throws Exception {
		File sourceFile = new File(sourceFilePath);
		File destFile = new File(destFilePath);
		if (sourceFile.exists() && sourceFile.isFile()) {
			if (!destFile.getParentFile().exists()) {
				destFile.getParentFile().mkdirs();
			}
			destFile.createNewFile();
			InputStream in = new FileInputStream(sourceFile);
			OutputStream out = new FileOutputStream(destFile);

			byte[] data = inputStreamToByte(in);
			//base64
			char[] aesData = DeformedBase64.encode(data);
			ByteArrayInputStream cin = StringToInputStream(getBytes(aesData));

//			byte[] aesData = SpecialSecret.aes256EncodeB(data, key.getBytes());
//			ByteArrayInputStream cin = StringToInputStream(aesData);


//			byte[] raw = key.getBytes();
//			SecretKeySpec secretKeySpec = new SecretKeySpec(raw, ALGORITHM);
//			Cipher cipher = Cipher.getInstance(ALGORITHM);
//			cipher.init(Cipher.ENCRYPT_MODE, secretKeySpec);
//			CipherInputStream cin = new CipherInputStream(in, cipher);

			int nRead = 0;
			while ((nRead = cin.read()) != -1) {
				out.write(nRead);
				out.flush();
			}

//			byte[] cache = new byte[CACHE_SIZE];
//			int nRead = 0;
//			while ((nRead = cin.read(cache)) != -1) {
//				out.write(cache, 0, nRead);
//				out.flush();
//			}
			out.close();
			cin.close();
			in.close();
		}
	}

	public static byte[] inputStreamToByte(InputStream input) throws IOException{
		byte[] b = new byte[input.available()];
		for (int n; (n = input.read(b)) != -1;) {
		}
		return b;
	}


	public static ByteArrayInputStream StringToInputStream(byte[] str){
		ByteArrayInputStream is = new ByteArrayInputStream(str);
		return is;
	}

	public static byte[] getBytes(char[] chars) {
		Charset cs = Charset.forName("UTF-8");
		CharBuffer cb = CharBuffer.allocate(chars.length);
		cb.put(chars);
		cb.flip();
		ByteBuffer bb = cs.encode(cb);
		return bb.array();
	}


	/**
	 * <p>
	 * 文件解密
	 * </p>
	 *
	 * @param key
	 * @param sourceFilePath
	 * @param destFilePath
	 * @throws Exception
	 */
	public static void decryptFile(String key, String sourceFilePath, String destFilePath) throws Exception {
		File sourceFile = new File(sourceFilePath);
		File destFile = new File(destFilePath);
		if (sourceFile.exists() && sourceFile.isFile()) {
			if (!destFile.getParentFile().exists()) {
				destFile.getParentFile().mkdirs();
			}
			destFile.createNewFile();
			FileInputStream in = new FileInputStream(sourceFile);
			FileOutputStream out = new FileOutputStream(destFile);
			byte[] raw = key.getBytes();
			SecretKeySpec secretKeySpec = new SecretKeySpec(raw, ALGORITHM);
			Cipher cipher = Cipher.getInstance(ALGORITHM);
			cipher.init(Cipher.DECRYPT_MODE, secretKeySpec);
			CipherOutputStream cout = new CipherOutputStream(out, cipher);
			byte[] cache = new byte[CACHE_SIZE];
			int nRead = 0;
			while ((nRead = in.read(cache)) != -1) {
				cout.write(cache, 0, nRead);
				cout.flush();
			}
			cout.close();
			out.close();
			in.close();
		}
	}

//	public static void downloadFileToPath(String sourceFilePath, String destFilePath) throws Exception{
//		   File sourceFile = new File(sourceFilePath);
//		   File destFile = new File(destFilePath);
//		   if (sourceFile.exists() && sourceFile.isFile()) {
//			   if (!destFile.getParentFile().exists()) {
//				   destFile.getParentFile().mkdirs();
//			   }
//			   destFile.createNewFile();
//			   FileInputStream in = new FileInputStream(sourceFile);
//			   FileOutputStream out = new FileOutputStream(destFile);
//
//			   byte[] cache = new byte[CACHE_SIZE];
//			   int nRead = 0;
//			   while ((nRead = in.read(cache)) != -1) {
//				   out.write(cache, 0, nRead);
//				   out.flush();
//			   }
//			   out.close();
//			   in.close();
//	}


	public static void downloadFileToPath(String sourceFilePath, String fileName, HttpServletResponse resp) throws Exception{
		String realName = fileName;
		try{
			realName =  URLEncoder.encode(realName,"utf-8");

		}catch (Exception e){

		}

		resp.setContentType("multipart/form-data");//通知浏览器数据类型
		resp.addHeader("Content-Disposition", "attachment;filename=" + realName);//告诉浏览器文件名
		ServletOutputStream out = null;

		try {
			File sourceFile = new File(sourceFilePath);
			if (sourceFile.exists() && sourceFile.isFile()) {

				FileInputStream in = new FileInputStream(sourceFile);
				out = resp.getOutputStream();

				byte[] data = inputStreamToByte(in);
				//base64
				char[] aesData = DeformedBase64.encode(data);
				ByteArrayInputStream cin = StringToInputStream(getBytes(aesData));

				int nRead = 0;
				while ((nRead = cin.read()) != -1) {
					out.write(nRead);
					out.flush();
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}





//	public static void main(String args[]) throws Exception{
//		String key = "5662e7c3d61fd5e0e67acd8bace6d1b0";
//		String sourceFilePath = "C:\\Users\\reyun\\Desktop\\reyunCrypto.jar";
//		String destFilePath = "C:\\Users\\reyun\\Desktop\\new.jar";
//		encryptFile(key, sourceFilePath,destFilePath);
////		decryptFile(key, destFilePath, sourceFilePath);
//
////		InputStream in = new FileInputStream(sourceFilePath);
////		System.out.println(inputStreamToString(in));
////		downloadFileToPath(sourceFilePath, "C:\\Users\\reyun\\Desktop\\mongo.jar");

//		String data = "{  \"initialFirmware\" : \"8.0\",  \"riskExist\" : \"0\",  \"systemVersion\" : \"11.1\",  \"isp\" : \"46001\",  \"netWorkType\" : \"WIFI\",  \"usedDiskValue\" : \"6363.00\",  \"iPhoneName\" : \"iPhone\",  \"purgableMemoryValue\" : \"7.95\",  \"totalMemoryValue\" : \"989.00\",  \"wifiDbm\" : \"-64\",  \"wifiAddress\" : \"fe80::14fb:2b53:573a:9331\",  \"platform\" : \"iOS\",  \"allBusFrequency\" : 0,  \"isDebugging\" : \"1\",  \"freeMemoryValue\" : \"55.17\",  \"totalDiskValue\" : \"15248.76\",  \"systemWiredMemoryValue\" : \"190.02\",  \"useLanuage\" : \"zh-Hans-CN\",  \"localDeviceIp\" : \"192.168.168.124\",  \"networkIp\" : \"119.57.108.226\",  \"isUsingVPN\" : \"0\",  \"cpuUsage\" : 0.2101379781961441,  \"reyunId\" : \"QLQ08\\/KgnyoqYZEPNp4bv\\/ySCP5QN\\/NxM348iR6qQZNcNLBKYeBEg54+ClBGny7P2L4plE8\\/le5ZNi4fvR708Sp15R7UMi7e5SYLmluIT5\\/1vGKeNbNck\\/5HTijdi\\/5lvMYG5S7JkR7hQ5QMgM8\\/CPN2QSQenbCfi5NRmPNvgZ\\/4CppKmE8ZMeroNsudlsBPgbXvcp7Tkbuqe3grcbYJCi8vlEP8veKiNDLoJc==\",  \"remainBattery\" : \"1647.10\",  \"systemName\" : \"iOS\",  \"batteryStatus\" : \"Charging\",  \"ramMemorySize\" : 1037041664,  \"isJailbreak\" : \"1\",  \"screenWidth\" : \"375.00\",  \"screenBrightness\" : \"0.56\",  \"cpuName\" : \"Apple A8\",  \"wifiStrength\" : 3,  \"deviceName\" : \"iPhone 6\",  \"idfv\" : \"BBEF0D9C-75A2-41D8-ACB3-0BB367965E37\",  \"cellStrength\" : 4,  \"ispName\" : \"中国联通\",  \"canMakePhoneCall\" : \"1\",  \"httpProxy\" : \"192.168.168.176\",  \"networkCountryIso\" : \"cn\",  \"screenHeight\" : \"667.00\",  \"batteryVoltage\" : \"3.82\",  \"httpPort\" : 8888,  \"batteryCapacityValue\" : \"1810\",  \"currentCountry\" : \"zh_CN\",  \"activeMemoryValue\" : \"474.96\",  \"iPhoneCellIP\" : \"null\",  \"gatewayAddress\" : \"192.168.168.1\",  \"idfa\" : \"8AAAC858-396E-4467-8B47-7EF1363B4EDD\",  \"appVersion\" : \"1.0\",  \"localizedModel\" : \"iPhone\",  \"ssidName\" : \"Reyun-online5G\",  \"latestSystemUptime\" : \"2019-09-20 18:25:29\",  \"usedMemoryValue\" : \"860.39\",  \"latestFirmware\" : \"12.3.1\",  \"deviceModel\" : \"iPhone7,2\",  \"perCPUUsage\" : \"0.18|0.03\",  \"isAppActive\" : \"1\",  \"batteryLevel\" : \"0.91\",  \"isInjection\" : \"0\",  \"isUsingProxy\" : \"1\",  \"cpuFrequency\" : 0,  \"cpuCounts\" : 2,  \"inActiveMemoryValue\" : \"195.41\",  \"freeDiskValue\" : \"8885.77\"}\n";
//		System.out.println(data.replaceAll("\\\\",""));
//		String str = data.replaceAll("\\\\","");
//		System.out.println(str);
//
//
//	}

}
